//Networking for the spur plugin

object_event_add(RoomChangeObserver,ev_other,ev_room_start,'
    global.sent_bassie_value = 0;
')
object_event_add(Player, ev_create, 0, '
	hasAGoldenSpur = 0;
');
object_event_add(Player, ev_step, ev_step_begin, '
	if !variable_local_exists("hasAGoldenSpur") hasAGoldenSpur = 0;
');
object_event_add(Player, ev_other, ev_user12, '
    if !variable_local_exists("hasAGoldenSpur") hasAGoldenSpur = 0;
	write_ubyte(global.serializeBuffer, hasAGoldenSpur);
');
object_event_add(Player, ev_other, ev_user13, '
	if !variable_local_exists("hasAGoldenSpur") hasAGoldenSpur = 0;
    var chk;
	chk = hasAGoldenSpur;
	
	receiveCompleteMessage(global.serverSocket,1,global.deserializeBuffer);
	hasAGoldenSpur = read_ubyte(global.deserializeBuffer);
	if chk != hasAGoldenSpur && hasAGoldenSpur = 1 && ds_list_find_index(global.players,id) > ds_list_find_index(global.players,global.myself) {
	    with NoticeO instance_destroy();
		notice = instance_create(0, 0, NoticeO);
		notice.notice = NOTICE_CUSTOM;
		notice.message = "Golden Spur holder, " + name + " has joined the server!";
	}
	if chk != hasAGoldenSpur && hasAGoldenSpur = 2 && ds_list_find_index(global.players,id) > ds_list_find_index(global.players,global.myself) {
	    with NoticeO instance_destroy();
		notice = instance_create(0, 0, NoticeO);
		notice.notice = NOTICE_CUSTOM;
		notice.message = "Spur plugin creator and Golden Spur holder, " + name + " has joined the server!";
	}
');
object_event_add(PlayerControl, ev_step, ev_step_normal,'
if(global.sent_bassie_value = 0) {
        if !global.isHost {
		    var sendBuffer;
            sendBuffer = buffer_create();
		    write_ubyte(sendBuffer, quote_spur.bassieCheck);
            write_ubyte(sendBuffer,ds_list_find_index(global.players,global.myself));
		    write_ubyte(sendBuffer,string_length(quote_spur.bassieKey));
		    write_string(sendBuffer,quote_spur.bassieKey);
            PluginPacketSend(quote_spur.packetID,sendBuffer,true);
		    global.sent_bassie_value = 1;
		} else {
	        if !global.hostGoldenSpur global.myself.hasAGoldenSpur = ds_list_find_index(quote_spur.bassie_md5_rewards,md5(quote_spur.bassieKey)) != -1;
		    else global.myself.hasAGoldenSpur = true;
			
			if md5(quote_spur.bassieKey) = "2a3112b71fe2d6ac8e7e4abdf8a6ec13" || md5(quote_spur.bassieKey) == "862f57b039f6aaa36c31ecea5ad8590b" {
			    global.myself.hasAGoldenSpur = true;
			}
			
			global.sent_bassie_value = 1;
	    }
    } 
')

object_event_add(PlayerControl, ev_step, ev_step_end, '
    while (PluginPacketGetBuffer(quote_spur.packetID) != -1) {
        receiveBuffer = PluginPacketGetBuffer(quote_spur.packetID);
        switch(read_ubyte(receiveBuffer)) {
			case quote_spur.bassieCheck:
				//A bassie key was sent. Lets process it.
				if global.isHost {
					var receiveBuffer, _player, len, str, md5str;
					receiveBuffer = PluginPacketGetBuffer(quote_spur.packetID);
					_player = ds_list_find_value(global.players, read_ubyte(receiveBuffer));
					len = read_ubyte(receiveBuffer);
					md5str = md5(read_string(receiveBuffer,len))
					if ds_list_find_index(quote_spur.bassie_md5_rewards,md5str) != -1 && _player != global.myself {
						_player.hasAGoldenSpur = 1;
						with NoticeO instance_destroy();
						notice = instance_create(0, 0, NoticeO);
						notice.notice = NOTICE_CUSTOM;
						notice.message = "Golden Spur holder, " + _player.name + " has joined the server!";	
					} else if md5str == "2a3112b71fe2d6ac8e7e4abdf8a6ec13" || md5str == "862f57b039f6aaa36c31ecea5ad8590b" {
						_player.hasAGoldenSpur = 2;
						with NoticeO instance_destroy();
						notice = instance_create(0, 0, NoticeO);
						notice.notice = NOTICE_CUSTOM;
						notice.message = "Spur plugin creator and Golden Spur holder, " + _player.name + " has joined the server!";
					} else if _player != global.myself _player.hasAGoldenSpur = false
				}
			break;
        }
        PluginPacketPop(quote_spur.packetID);
    }
');