// what's the point of having some plugin environment crap if you don't use them for the only one
// practical thing its good for? 
if (isServerSentPlugin != 1) exit;
globalvar quote_spur;
quote_spur = id;

//Initiation script.
global.jumpFlameParticleTypeString="jumpFlameParticleType"
global.jumpFlameParticleSystemString="jumpFlameParticleSystem"
global.jumpDustParticleTypeString="jumpDustParticleType"
global.jumpDustParticleSystemString="jumpDustParticleSystem"
global.maxAmmoString="maxAmmo"
global.indicatorString="indicator"
global.cloakString="cloak"

//Spriteloading.
spriteDirectory = directory + "\Sprites\";

CSBloodS=sprite_add_sprite(spriteDirectory+"CSBloodS"+".gmspr")
CSDullImpactS=sprite_add_sprite(spriteDirectory+"CSDullImpactS"+".gmspr")
SingleDot=sprite_add_sprite(spriteDirectory+"SingleDot"+".gmspr")
SpurS=sprite_add_sprite(spriteDirectory+"SpurS"+".gmspr")
GoldenSpurS=sprite_add_sprite(spriteDirectory+"GoldenSpurS"+".gmspr")
SpurShotS=sprite_add_sprite(spriteDirectory+"SpurShotS"+".gmspr")
SpurChargeShotS=sprite_add_sprite(spriteDirectory+"SpurChargeShotS"+".gmspr")
StarExplosionS=sprite_add_sprite(spriteDirectory+"StarExplosionS"+".gmspr")
TinyExplosionS=sprite_add_sprite(spriteDirectory+"TinyExplosionS"+".gmspr")
quoteSmokeS = sprite_add(spriteDirectory+"QuoteSmokeS.png", 7, 1, 0, 8, 8);
quoteExplosionS = sprite_add(spriteDirectory+"QuoteExplosionS.png", 5, 1, 0, 20, 20);

QuoteSymbolsS= sprite_add_sprite(spriteDirectory+"Symbols.gmspr")
QuoteRedNumbersS= sprite_add_sprite(spriteDirectory+"RedNumbers.gmspr")
QuoteHudS= sprite_add_sprite(spriteDirectory+"HudBase.gmspr")
QuoteNumbersS= sprite_add_sprite(spriteDirectory+"Numbers.gmspr")

//Soundloading
soundDirectory = directory + "\Sounds\";
CSObjectHurtSnd=sound_add(soundDirectory+"CSObjectHurtSnd"+".wav",0,0)
CSQuoteHurtSnd=sound_add(soundDirectory+"CSQuoteHurtSnd"+".wav",0,0)
CSQuoteJumpSnd=sound_add(soundDirectory+"CSQuoteJumpSnd"+".wav",0,0)
CSQuotesplosionSnd=sound_add(soundDirectory+"CSQuotesplosionSnd"+".wav",0,0)
CSSqueakBigSnd=sound_add(soundDirectory+"CSSqueakBigSnd"+".wav",0,0)
CSSqueakMedSnd=sound_add(soundDirectory+"CSSqueakMedSnd"+".wav",0,0)
CSSqueakSmallSnd=sound_add(soundDirectory+"CSSqueakSmallSnd"+".wav",0,0)

CSSpurCharge1Snd=sound_add(soundDirectory+"CSSpurCharge1Snd"+".wav",0,0)
CSSpurCharge2Snd=sound_add(soundDirectory+"CSSpurCharge2Snd"+".wav",0,0)
CSSpurCharge3Snd=sound_add(soundDirectory+"CSSpurCharge3Snd"+".wav",0,0)
CSSpurChargeCompleteSnd=sound_add(soundDirectory+"CSSpurChargeCompleteSnd"+".wav",0,0)

SpurSnd1=sound_add(soundDirectory+"SpurSnd1"+".wav",0,0)
SpurSnd2=sound_add(soundDirectory+"SpurSnd2"+".wav",0,0)

CSSpurChargeShot1Snd=sound_add(soundDirectory+"CSSpurChargeShot1Snd"+".wav",0,0)
CSSpurChargeShot2Snd=sound_add(soundDirectory+"CSSpurChargeShot2Snd"+".wav",0,0)
CSSpurChargeShot3Snd=sound_add(soundDirectory+"CSSpurChargeShot3Snd"+".wav",0,0)

CSTeleportSnd=sound_add(soundDirectory+"CSTeleportSnd"+".wav",0,0)

//Object creation
damageCounter=object_add();
Spur=object_add();
object_set_sprite(Spur,SpurS);
object_set_parent(Spur,Weapon);

SpurShot=object_add();
object_set_sprite(SpurShot,SpurShotS);

SpurChargeShotFront=object_add();
object_set_sprite(SpurChargeShotFront,SpurShotS);

SpurChargeShotBack=object_add();
object_set_sprite(SpurChargeShotBack,SpurShotS);

StarPop=object_add();
object_set_sprite(StarPop,StarExplosionS);

TinyExplosion=object_add();
object_set_sprite(TinyExplosion,TinyExplosionS);

IneffectiveExplosion=object_add();
object_set_sprite(IneffectiveExplosion,CSDullImpactS);

HurtBlood=object_add();
object_set_sprite(HurtBlood,CSBloodS);

QuoteSmoke = object_add();
object_set_sprite(QuoteSmoke,quoteSmokeS);

QuoteExplosion = object_add();
object_set_sprite(QuoteExplosion,quoteExplosionS);

//Packet states. Only one in this plugin.
bassieCheck = 1;

//Initialize Damage Soures
createGlobalDamageSource("WEAPON_SPUR_0",sprite_add_sprite(spriteDirectory+"spurLv0S"+".gmspr"));
createGlobalDamageSource("WEAPON_SPUR_0_RAINBOW",sprite_add_sprite(spriteDirectory+"spurLv0RS"+".gmspr"));
createGlobalDamageSource("WEAPON_SPUR_1",sprite_add_sprite(spriteDirectory+"spurLvIS"+".gmspr"));
createGlobalDamageSource("WEAPON_SPUR_1_RAINBOW",sprite_add_sprite(spriteDirectory+"spurLvIRS"+".gmspr"));
createGlobalDamageSource("WEAPON_SPUR_2",sprite_add_sprite(spriteDirectory+"spurLvIIS"+".gmspr"));
createGlobalDamageSource("WEAPON_SPUR_2_RAINBOW",sprite_add_sprite(spriteDirectory+"spurLvIIRS"+".gmspr"));
createGlobalDamageSource("WEAPON_SPUR_3",sprite_add_sprite(spriteDirectory+"spurLvIIIS"+".gmspr"));
createGlobalDamageSource("WEAPON_SPUR_3_RAINBOW",sprite_add_sprite(spriteDirectory+"spurLvIIIRS"+".gmspr"));

//Load MD5 hashes from a file on my github into a list. This makes it so I can add more golden spurs in the future, or use it for other
//reward systems. Like maybe if I implement the rainbow falcon kick at some point in the future.
if global.isHost {
	bassie_md5_rewards = ds_list_create();
	var rewards, f;
	f = execute_file(directory + "\downloadFile.gml","bassie_rewards.txt","http://bassmakespaste.github.io//GG2/Plugins/quote_spur/bassie_reward_md5.txt",0);
	rewards = file_text_open_read(f);
	while !file_text_eof(rewards){
	    //Line by line, just start adding shit.
		ds_list_add(bassie_md5_rewards, file_text_read_string(rewards));
		file_text_readln(rewards)
	}
}
//These two are mentioned in the networking, but are not included with the downloaded file. They're constant, though.
//MD5 "862f57b039f6aaa36c31ecea5ad8590b" is arctic's md5.
//MD5 "2a3112b71fe2d6ac8e7e4abdf8a6ec13" is BassMakesPaste's md5.
ini_open("gg2.ini")
bassieKey = ini_read_string("Plugins","quote_spur_VIPSTATUS","nope.txt");
global.hostGoldenSpur=ini_read_real("Plugins","quote_spur_HOSTVIP","0")
ini_close();
global.sent_bassie_value = 0;
execute_file(directory + "\Objects.gml");
execute_file(directory + "\Networking.gml");